# -*- coding: utf-8 -*-

# Copyright (C) 2010  Dustin Widmann <1m.0n.f1r3@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

from PyQt4.QtCore import *
from PyKDE4.kdecore import *
from PyKDE4 import plasmascript
import re
import urllib, urllib2

class EngineFAPMonitor(plasmascript.DataEngine):
	def __init__(self,parent,args=None):
		plasmascript.DataEngine.__init__(self,parent)
	def init(self):
		self.setMinimumPollingInterval(60000)
	def sources(self):
		sources = ["HN9000","WildBlue"]
		return sources
	def sourceRequestEvent(self,name):
		return self.updateSourceEvent(name)
	def updateSourceEvent(self,name):
		if name == "HN9000":
			current_status = 'gray'
			download_allowance = -1
			upload_allowance = -1
			download_remaining = -1
			upload_remaining = -1
			download_current = -1
			upload_current = -1
			refill = -1
			fap_soup = False
			status_soup = False
			try:
				fap_soup =urllib.urlopen('http://192.168.0.1/stlui/user/allowance_request.html').read()
			except:
				fap_soup = False # Just to be sure ...
			if fap_soup != False:
				fap_soup = re.sub('<.*?>','\n',fap_soup)
				fap_soup = re.sub('&nbsp;',' ',fap_soup)
				fap_soup = re.sub('\s{2,}','\n',fap_soup)
				fap_parsed = fap_soup.split('\n')
				x = 0
				while x < len(fap_parsed):
					if fap_parsed[x] == "Plan Allowance (MB)":
						self.setData(name,"hn9_download_allowance",QVariant(fap_parsed[x+1]))
					if fap_parsed[x] == "Allowance Remaining (MB)":
						self.setData(name,"hn9_download_remaining",QVariant(fap_parsed[x+1]))
					if fap_parsed[x] == 'Time Until Allowance Refill':
						self.setData(name,"hn9_refill",QVariant(fap_parsed[x+1]))
					x = x +1

			try:
				status_soup = urllib.urlopen('http://192.168.0.1/stlui/user/status_bar.html').read()
			except:
				self.setData(name,"hn9_current_status",QVariant('gray'))
				status_soup = False # Again, just to be sure
			if not status_soup == False:
				if status_soup.find('red.gif') > 0 :
					self.setData(name,"hn9_current_status",QVariant('red'))
				elif status_soup.find('yellow.gif') > 0:
					self.setData(name,"hn9_current_status",QVariant('yellow'))
				elif status_soup.find('orange.gif') > 0:
					self.setData(name,"hn9_current_status",QVariant('orange'))
				elif status_soup.find('green.gif') > 0:
					self.setData(name,"hn9_current_status",QVariant('green'))
				else:
					self.setData(name,"hn9_current_status",QVariant('gray'))
					
		elif name == "WildBlue":
			wbsoup = False
			try:
				if not wbusername == "ChangeMe" and not wbusername == "ChangeMe":
					o = urllib2.build_opener( urllib2.HTTpCookieProcessor() )
					urllib2.install_opener( o )
					p = urllib.urlencode( { 'mainForm:username': self.wbusername, 'mainForm:password': self.wbpassword } )
					f = o.open('https://myusage.wildblue.net/UsageGUI/pages/webapp-index.xhtml', p )
					data = f.read()
					f.close()
					f = o.open( 'https://myusage.wildblue.net/UsageGUI/pages/webapp-index.xhtml' )
					wbsoup = f.read()
				else:
					raise
			except:
				wbsoup = False
			if not wbsoup == False:
				wbsoup = re.sub('<.*?>','\n',wbsoup)
				wbsoup = re.sub('\s{2,}','\n',wbsoup)
				wb_parsed = wbsoup.split('\n')
				x = 0
				current_status = 'gray'
				upload_current = ""
				upload_remaining = ""
				download_current = ""
				download_remaining = ""
				upload_allowance = ""
				while x < len(wb_parsed):
					if wb_parsed[x] == 'FAP Status:':
						current_status = wb_parsed[x+1]
					elif wb_parsed[x] == 'Download':
						download_current = wb_parsed[x+2]
						download_allowance = wb_parsed[x+3]
						self.setData(name,"wb_download_remaining",QVariant(float(download_allowance) - float(download_current)))
						self.setData(name,"wb_download_allowance",QVariant(download_allowance))
					elif wb_parsed[x] == 'Upload':
						upload_current = wb_parsed[x+2]
						upload_allowance = wb_parsed[x+3]
						self.setData(name,"wb_upload_remaining",QVariant(float(upload_allowance) - float(upload_current)))
						self.setData(name,"wb_upload_allowance",QVariant(upload_allowance))
					x = x + 1
				if current_status == '(Not in violation)':
					self.setData(name,"wb_current_status",QVariant('green'))
				elif current_status == 'gray':
					self.setData(name,"wb_current_status",QVariant('gray'))
				else:
					self.setData(name,"hn9_current_status",QVariant('orange'))
		return True

def CreateDataEngine(parent):
	return EngineFAPMonitor(parent)
